#!/bin/bash

#
#  Install script for Fixpoint Mathematical Library 
#  URL: http://code.google.com/p/fixpointlib/
#
#  Script written by Gregor Rebel 2010-2011.
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on:
# Ubuntu 10.04 Netbook Edition x86
# KUbuntu 11.04 x86
# openSuSE 11.4 x86
# XUbuntu 11.10 x64

source scripts/installFuncs.sh

if [ "$USER" == "root" ]; then
  echo "$0: ERROR this script should not been run as user root!"
  exit 10
fi

INSTALLPATH="FixPointLib"
dir $INSTALLPATH
cd $INSTALLPATH

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW -----------------------------------------------

if [ ! -e OK.Install ]; then #{
  echo "installing in $INSTALLPATH ..."
  InstallDir=`pwd`
  
  InstallInHomeDir="1"
  if [ "$InstallInHomeDir" == "1" ]; then
    Prefix=`pwd`  # install into subfolder of ToolChain/ for current user only
  else
    findPrefix    # install for all users
  fi
  
  if [ ! -e OK.Packages ]; then #{
    installPackage svn
    installPackage subversion
    touch OK.Packages
  fi #}
  
  OldDir=`pwd`
  cd ../../Documentation
  get http://www.isep.pw.edu.pl/ZakladNapedu/lab-skp/ IQmath.pdf Overview.html FixPointLib_IQMath_Manual.pdf
  get http://code.google.com/p/fixpointlib/ Overview.html FixPointLib_IQMath_Overview.html
  cd $OldDir
  svn checkout http://fixpointlib.googlecode.com/svn/trunk/ fixpointlib-read-only
  
  Folder="fixpointlib-read-only/CortexM3/Project/FixPointLibTest/uVisionGcc"
  if [ -d ${Folder} ]; then
    cp -R $Folder .
    add2CleanUp ../cleanup.sh "rm -Rf $INSTALLPATH/fixpointlib-read-only"
    if [ -e IQmath.pdf ]; then
      rm 2>/dev/null uVisionGcc/IQmath.pdf
      ln IQmath.pdf uVisionGcc/
    fi  
  fi
  
  if [ -d uVisionGcc ]; then
    
    cat <<END_OF_MAKEFILE >../extensions/makefile.$INSTALLPATH
#
#                               ToolChain_STM32
#
#                         Extension to central makefile
#
#                   makefile written by Gregor Rebel 2010-2011
#

EXTENSION_$INSTALLPATH = 1

ifdef EXTENSION_$INSTALLPATH

# activate certain parts of source-code
COMPILE_OPTS += -DEXTENSION_FIXPOINT_LIB

INCLUDE_DIRS += -I FixPointLib/
LD_LIBS += FixPointLib/FixPointLib.lib

endif

END_OF_MAKEFILE

    echo "" >OK.Install
  fi
  #cd ..
fi #} [ ! -e OK.Install ]; then
if [   -e OK.Install ]; then #{
  addLine ../scripts/createLinks.sh 'rm 2>/dev/null FixPointLib;           ln -sv $Source/ToolChain_STM32/ToolChain/FixPointLib/uVisionGcc/                                   FixPointLib'
  echo "Installed successfully: $INSTALLPATH"
#}
else
  echo "failed to install $INSTALLPATH"
  exit 10
fi

cd ..
#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

exit 0
